#include <bits/stdc++.h>

using namespace std;

const int maxn = 300005;

int n, q;

int idx[maxn];

long long tree[maxn * 4];
long long lazy[maxn * 4];

void push_lazy(int node, int l, int r)
{
    tree[node] += (1LL * (r - l + 1)) * lazy[node];

    if (l != r)
    {
        lazy[node * 2] += lazy[node];
        lazy[node * 2 + 1] += lazy[node];
    }

    lazy[node] = 0;
}

void update(int node, int l, int r, int ql, int qr, int delta)
{
    push_lazy(node, l, r);

    if (l > qr | r < ql)
    {
        return;
    }

    if (ql <= l && r <= qr)
    {
        lazy[node] += delta;
        push_lazy(node, l, r);
        return;
    }

    int mid = (l + r) / 2;

    update(node * 2, l, mid, ql, qr, delta);
    update(node * 2 + 1, mid + 1, r, ql, qr, delta);

    tree[node] =tree[node * 2] + tree[node * 2 + 1];
}

long long query(int node, int l, int r, int ql, int qr)
{
    push_lazy(node, l, r);

    if (l > qr || r < ql)
    {
        return 0;
    }

    if (ql <= l && r <= qr)
    {
        return tree[node];
    }

    int mid = (l + r) / 2;

    return query(node * 2, l, mid, ql, qr) + query(node * 2 + 1, mid + 1, r, ql, qr);
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> q;

    deque<int> dq;

    for (int i = 1; i <= n; ++i)
    {
        int x;
        cin >> x;
        idx[x] = i;
        dq.push_back(x);
    }

    string ans;

    while (q--)
    {
        int type;
        cin >> type;

        if (type ==1)
        {
            int x;
            cin >> x;

            if (x == 1)
            {
                x = dq.front();
                dq.pop_front();
            }
            else
            {
                x = dq.back();
                dq.pop_back();
            }

            //cout << idx[x] << " -> " << query(1, 1, n, idx[x], idx[x]) << endl;

            if (query(1, 1, n, idx[x], idx[x]) >= 1)
            {
                ans.push_back('1');
            }
            else
            {
                ans.push_back('0');
            }
        }
        else
        {
            int x, y;
            cin >> x >> y;

            //cout << "updating from " << idx[x] << " to " << idx[y] << endl;

            update(1, 1, n, idx[x], idx[y], 1);
        }
    }

    cout << ans << endl;

    return 0;
}
