#include<bits/stdc++.h>
using namespace std;

const long long MAX_N = 1e5 + 10;
const long long INF = 1e9;
long long n, q;

int a[MAX_N];
int tree[MAX_N * 4];
int startInd = 1, endInd = n;
int indOf[MAX_N];
int totalInInterval (int l1, int r1, int l2, int r2) {
    if (l1 > r2 || r1 < l2) return 0;
    if (l1 <= l2 && r2 <= r1) return r2 - l2 + 1;
    if (l2 <= l1 && r1 <= r2) return r1 - l1 + 1;
    if (l2 >= l1 && l2 <= r1) return r1 - l2 + 1;
    return r2 - l1 + 1;
}

void build (int i, int l, int r) {
    if (l == r){
        tree[i] = a[l];
        return;
    }
    int mid = (l + r) / 2;
    build(i * 2, l, mid);
    build(i * 2 + 1, mid + 1, r);

    tree[i] = tree[i * 2] + tree[i * 2 + 1];
}

pair<int, pair<int, int>> lazy[4 * MAX_N];

void push_lazy (int i, int l, int r) {
    if(lazy[i].first == 0) return;
    //cout << l << " " << r << " " << lazy[i].second.first << " " << lazy[i].second.second << " " << totalInInterval(l, r, lazy[i].second.first, lazy[i].second.second) << endl;
    tree[i] += totalInInterval(l, r, lazy[i].second.first, lazy[i].second.second) * lazy[i].first;
    int mid = (l + r) / 2;
    push_lazy(i * 2, l, mid);
    push_lazy(i * 2 + 1, mid + 1, r);
    lazy[i * 2] = {lazy[i].first, {lazy[i].second.first, lazy[i].second.second}};
    lazy[i * 2 + 1] = {lazy[i].first, {lazy[i].second.first, lazy[i].second.second}};
}


bool isSmart (int i, int l, int r, int v) {
    push_lazy(i, l, r);
    if (l == r && l == v) {
        return tree[i] > 0;
    }
    if (l > v || r < v) return false;
    int mid = (l + r) / 2;
    return isSmart(i * 2, l, mid, v) || isSmart(i * 2 + 1, mid + 1, r, v);
}


void updateRange (int tl, int tr, int delta) {
    push_lazy(1, 1, n);
    lazy[1] = {delta, {tl, tr}};
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> q;

    for (int i = 1; i <= n; i ++) {
        int x; cin >> x;
        indOf[x] = i;
        a[i] = 0;
    }
    build(1, 1, n);
    for (int QUERY = 1; QUERY <= q; QUERY ++) {
        int t; cin >> t;
        if (t == 1) {
            int p; cin >> p;
            if (p == 1) {
                cout << isSmart(1, 1, n, startInd);
                startInd ++;
            } else {
                cout << isSmart(1, 1, n, endInd);
                endInd --;
            }
        } else if (t == 2) {
            int x, y;
            cin >> x >> y;
            //cout << indOf[x] << " " << indOf[y] << endl;
            updateRange(indOf[x], indOf[y], 1);
        } else if (t == 3) {
            return 0;
        }
        /**
        for (int i = 1; i <= n * 4; i ++) {
            cout << i << ". " << tree[i] << endl;
        }
        **/
    }

    return 0;
}
