#include <bits/stdc++.h>
using namespace std;

const int MAXN=4*1e5+1;
int N, Q;
int awards[MAXN];
int L, R;
pair<int, int> neighbours[MAXN];

void read()
{
    cin >> N >> Q;
    int previous_student=0;

    for(int i=1; i<=N; i++)
    {
        int student;
        cin >> student;

        if(i==1)
        {
            L=student;
        }
        else if(i==N)
        {
            R=student;
        }

        neighbours[student].first=previous_student;
        neighbours[previous_student].second=student;
        previous_student=student;
    }
}

void update(const int& x, const int& y, const int& z)
{
    neighbours[x].second=z;
    neighbours[y].first=z;
    neighbours[z].first=x;
    neighbours[z].second=y;
}

void query(const int& p)
{
    if(p==1)
    {
        cout << awards[L];
        L=neighbours[L].second;
    }
    else
    {
        cout << awards[R];
        R=neighbours[R].first;
    }
}

void awarding(const int& x, const int& y)
{
    int i=x;
    awards[i]=1;

    while(true)
    {
        i=neighbours[i].second;
        awards[i]=1;
        if(i==y)
        {
            break;
        }
    }
}

void solve()
{
    while(Q--)
    {
        int t;
        cin >> t;

        if(t==1)
        {
            int p;
            cin >> p;
            query(p);
        }
        else if(t==2)
        {
            int x, y;
            cin >> x >> y;
            awarding(x, y);
        }
        else
        {
            int x, y, z;
            cin >> x >> y >> z;
            update(x, y, z);
        }

        /*
        for(int i=1; i<=2*N; i++)
        {
            cout << i << " - > " << neighbours[i].first << ", " << neighbours[i].second << '\n';
        }

        cout << "////";
        cout << '\n';
        */
        ///cout << L << " " << R << '\n';
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
    return 0;
}
