#include <bits/stdc++.h>
using namespace std;

const long long MAXN=4*1e5+1;
long long N, Q;
long long awards[MAXN];
long long L, R;
pair<long long, long long> neighbours[MAXN];

void read()
{
    cin >> N >> Q;
    long long previous_student=0;

    for(long long i=1; i<=N; i++)
    {
        long long student;
        cin >> student;

        if(i==1)
        {
            L=student;
        }
        else if(i==N)
        {
            R=student;
        }

        neighbours[student].first=previous_student;
        neighbours[previous_student].second=student;
        previous_student=student;
    }
}

void update(long long x, long long y, long long z)
{
    if(y==L)
    {
        L=z;
    }

    if(x==R)
    {
        R=z;
    }

    neighbours[x].second=z;
    neighbours[y].first=z;
    neighbours[z].first=x;
    neighbours[z].second=y;
}

void query(long long p)
{
    if(p==1)
    {
        cout << awards[L];
        L=neighbours[L].second;
    }
    else
    {
        cout << awards[R];
        R=neighbours[R].first;
    }
}

void awarding(int x, int y)
{
    long long i=x;
    awards[i]=1;

    if(x==y)
    {
        return;
    }

    while(true)
    {
        i=neighbours[i].second;
        awards[i]=1;
        if(i==y)
        {
            break;
        }
    }
}

void solve()
{
    while(Q--)
    {
        long long t;
        cin >> t;

        if(t==1)
        {
            long long p;
            cin >> p;
            query(p);
        }
        else if(t==2)
        {
            long long x, y;
            cin >> x >> y;
            awarding(x, y);
        }
        else
        {
            long long x, y, z;
            cin >> x >> y >> z;
            update(x, y, z);
        }

        /*
        for(int i=1; i<=2*N; i++)
        {
            cout << i << " - > " << neighbours[i].first << ", " << neighbours[i].second << '\n';
        }

        cout << "////";
        cout << '\n';
        */
        ///cout << L << " " << R << '\n';
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
    return 0;
}
