# include <iostream>
# include <utility>
# include <algorithm>
using namespace std;

const int MAX=3*1e5+1;

int n,q;
int a[MAX];
int f[MAX];
bool tree[MAX*4];

void update(int x, int y, int v=1, int l=1, int r=n)
{
     if(y<l or r<x) return ;
     if(x<=l and r<=y)
     {
         tree[v]=1;
         return ;
     }

     int mid=(l+r)/2;
     update(x,y,v*2,l,mid);
     update(x,y,v*2+1,mid+1,r);
}

bool query(int id, int v=1, int l=1, int r=n)
{
    if(l==r and l==id) return tree[v];

    int mid=(l+r)/2;
    if(id<=mid) return max(tree[v],query(id,v*2,l,mid));
    else return max(tree[v],query(id,v*2+1,mid+1,r));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>q;
    for(int i=1; i<=n; i++)
    {
       cin>>a[i];
       f[a[i]]=i;
    }

    int l_del=1,r_del=n;
    while(q--)
    {
        int t;
        cin>>t;
        if(t==1)
        {
            int x;
            cin>>x;

            if(x==1)
            {
                cout<<query(l_del);
                l_del++;
            }
            else
            {
                cout<<query(r_del);
                r_del--;
            }
        }
        else if(t==2)
        {
            int x,y;
            cin>>x>>y;
            update(f[x],f[y]);
        }
    }
    return 0;
}

